Index: uspace/srv/audio/hound/hound_ctx.c
===================================================================
--- uspace/srv/audio/hound/hound_ctx.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/audio/hound/hound_ctx.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -403,5 +403,5 @@
 		return ENOMEM;
 	}
-	log_verbose("CTX: %p: Mixing %u streams", ctx,
+	log_verbose("CTX: %p: Mixing %lu streams", ctx,
 	    list_count(&ctx->streams));
 	pcm_format_silence(buffer, size, &source->format);
@@ -413,5 +413,5 @@
 			log_warning("Not enough data in stream buffer");
 	}
-	log_verbose("CTX: %p. Pushing audio to %u connections", ctx,
+	log_verbose("CTX: %p. Pushing audio to %lu connections", ctx,
 	    list_count(&source->connections));
 	list_foreach(source->connections, source_link, connection_t, conn) {
Index: uspace/srv/audio/hound/main.c
===================================================================
--- uspace/srv/audio/hound/main.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/audio/hound/main.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -85,5 +85,5 @@
 	hound_iface.server = &hound;
 	hound_service_set_server_iface(&hound_iface);
-	async_set_client_connection(hound_connection_handler);
+	async_set_fallback_port_handler(hound_connection_handler, NULL);
 
 	service_id_t id = 0;
Index: uspace/srv/bd/file_bd/file_bd.c
===================================================================
--- uspace/srv/bd/file_bd/file_bd.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/bd/file_bd/file_bd.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -157,5 +157,5 @@
 	bd_srvs.ops = &file_bd_ops;
 	
-	async_set_client_connection(file_bd_connection);
+	async_set_fallback_port_handler(file_bd_connection, NULL);
 	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
Index: uspace/srv/bd/part/guid_part/guid_part.c
===================================================================
--- uspace/srv/bd/part/guid_part/guid_part.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/bd/part/guid_part/guid_part.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -160,5 +160,5 @@
 	}
 
-	rc = block_init(EXCHANGE_SERIALIZE, indev_sid, 2048);
+	rc = block_init(indev_sid, 2048);
 	if (rc != EOK)  {
 		printf(NAME ": could not init libblock.\n");
@@ -185,5 +185,5 @@
 
 	/* Register server with location service. */
-	async_set_client_connection(gpt_connection);
+	async_set_fallback_port_handler(gpt_connection, NULL);
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
@@ -339,7 +339,7 @@
 
 	/* Get the device handle. */
-	dh = IPC_GET_ARG1(*icall);
-
-	/* 
+	dh = IPC_GET_ARG2(*icall);
+
+	/*
 	 * Determine which partition device is the client connecting to.
 	 * A linear search is not terribly fast, but we only do this
Index: uspace/srv/bd/part/mbr_part/mbr_part.c
===================================================================
--- uspace/srv/bd/part/mbr_part/mbr_part.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/bd/part/mbr_part/mbr_part.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -210,5 +210,5 @@
 	}
 
-	rc = block_init(EXCHANGE_SERIALIZE, indev_sid, 2048);
+	rc = block_init(indev_sid, 2048);
 	if (rc != EOK)  {
 		printf(NAME ": could not init libblock.\n");
@@ -235,5 +235,5 @@
 
 	/* Register server with location service. */
-	async_set_client_connection(mbr_connection);
+	async_set_fallback_port_handler(mbr_connection, NULL);
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
@@ -416,7 +416,7 @@
 
 	/* Get the device handle. */
-	dh = IPC_GET_ARG1(*icall);
-
-	/* 
+	dh = IPC_GET_ARG2(*icall);
+
+	/*
 	 * Determine which partition device is the client connecting to.
 	 * A linear search is not terribly fast, but we only do this
Index: uspace/srv/bd/rd/rd.c
===================================================================
--- uspace/srv/bd/rd/rd.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/bd/rd/rd.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -178,5 +178,5 @@
 	bd_srvs.ops = &rd_bd_ops;
 	
-	async_set_client_connection(rd_client_conn);
+	async_set_fallback_port_handler(rd_client_conn, NULL);
 	ret = loc_server_register(NAME);
 	if (ret != EOK) {
Index: uspace/srv/bd/sata_bd/sata_bd.c
===================================================================
--- uspace/srv/bd/sata_bd/sata_bd.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/bd/sata_bd/sata_bd.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -172,5 +172,5 @@
 
 	/* Get the device service ID. */
-	dsid = IPC_GET_ARG1(*icall);
+	dsid = IPC_GET_ARG2(*icall);
 
 	/* Determine which disk device is the client connecting to. */
@@ -247,5 +247,5 @@
 	int rc;
 	
-	async_set_client_connection(sata_bd_connection);
+	async_set_fallback_port_handler(sata_bd_connection, NULL);
 	rc = loc_server_register(NAME);
 	if (rc < 0) {
Index: uspace/srv/bd/vbd/disk.c
===================================================================
--- uspace/srv/bd/vbd/disk.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/bd/vbd/disk.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -360,5 +360,5 @@
 	rc = vbds_disk_by_svcid(sid, &disk);
 	if (rc == EOK)
-		return EEXISTS;
+		return EEXIST;
 
 	disk = calloc(1, sizeof(vbds_disk_t));
@@ -374,5 +374,5 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "block_init(%zu)", sid);
-	rc = block_init(EXCHANGE_SERIALIZE, sid, 2048);
+	rc = block_init(sid, 2048);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed opening block device %s.",
@@ -872,5 +872,5 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_bd_conn()");
 
-	svcid = IPC_GET_ARG1(*icall);
+	svcid = IPC_GET_ARG2(*icall);
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_bd_conn() - svcid=%zu", svcid);
Index: uspace/srv/bd/vbd/vbd.c
===================================================================
--- uspace/srv/bd/vbd/vbd.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/bd/vbd/vbd.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -64,5 +64,5 @@
 		return rc;
 
-	async_set_client_connection(vbds_client_conn);
+	async_set_fallback_port_handler(vbds_client_conn, NULL);
 
 	rc = loc_server_register(NAME);
@@ -415,5 +415,5 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_client_conn()");
 
-	sid = (service_id_t)IPC_GET_ARG1(*icall);
+	sid = (service_id_t)IPC_GET_ARG2(*icall);
 
 	if (sid == ctl_sid)
Index: uspace/srv/clipboard/clipboard.c
===================================================================
--- uspace/srv/clipboard/clipboard.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/clipboard/clipboard.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -180,5 +180,5 @@
 	printf("%s: HelenOS clipboard service\n", NAME);
 	
-	async_set_client_connection(clip_connection);
+	async_set_fallback_port_handler(clip_connection, NULL);
 	int rc = service_register(SERVICE_CLIPBOARD);
 	if (rc != EOK)
Index: uspace/srv/devman/client_conn.c
===================================================================
--- uspace/srv/devman/client_conn.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/devman/client_conn.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -726,5 +726,5 @@
 
 /** Function for handling connections from a client to the device manager. */
-void devman_connection_client(ipc_callid_t iid, ipc_call_t *icall)
+void devman_connection_client(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
 	/* Accept connection. */
Index: uspace/srv/devman/client_conn.h
===================================================================
--- uspace/srv/devman/client_conn.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/devman/client_conn.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -36,5 +36,5 @@
 #include "devman.h"
 
-extern void devman_connection_client(ipc_callid_t, ipc_call_t *);
+extern void devman_connection_client(ipc_callid_t, ipc_call_t *, void *);
 
 #endif
Index: uspace/srv/devman/driver.c
===================================================================
--- uspace/srv/devman/driver.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/devman/driver.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -36,5 +36,4 @@
 #include <sys/stat.h>
 #include <io/log.h>
-#include <ipc/driver.h>
 #include <loc.h>
 #include <str_error.h>
@@ -143,5 +142,5 @@
 	/* Check whether the driver's binary exists. */
 	struct stat s;
-	if (stat(drv->binary_path, &s) == ENOENT) { /* FIXME!! */
+	if (stat(drv->binary_path, &s) != 0) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Driver not found at path `%s'.",
 		    drv->binary_path);
@@ -573,11 +572,11 @@
 	
 	if (rc != EOK) {
-		/* TODO handle error */
-	}
-
-	/* Wait for answer from the driver. */
-	async_wait_for(req, &rc);
-
-	switch(rc) {
+		async_forget(req);
+	} else {
+		/* Wait for answer from the driver. */
+		async_wait_for(req, &rc);
+	}
+
+	switch (rc) {
 	case EOK:
 		dev->state = DEVICE_USABLE;
@@ -592,6 +591,4 @@
 	
 	dev->passed_to_driver = true;
-
-	return;
 }
 
Index: uspace/srv/devman/drv_conn.c
===================================================================
--- uspace/srv/devman/drv_conn.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/devman/drv_conn.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -49,5 +49,4 @@
 #include <io/log.h>
 #include <ipc/devman.h>
-#include <ipc/driver.h>
 #include <loc.h>
 
@@ -102,5 +101,5 @@
 		    driver->name);
 		fibril_mutex_unlock(&driver->driver_mutex);
-		async_answer_0(callid, EEXISTS);
+		async_answer_0(callid, EEXIST);
 		return NULL;
 	}
@@ -131,5 +130,5 @@
 	}
 	/* FIXME: Work around problem with callback sessions */
-	async_sess_args_set(driver->sess, DRIVER_DEVMAN, 0, 0);
+	async_sess_args_set(driver->sess, INTERFACE_DDF_DEVMAN, 0, 0);
 	
 	log_msg(LOG_DEFAULT, LVL_NOTE,
@@ -279,5 +278,5 @@
 		fibril_rwlock_write_unlock(&tree->rwlock);
 		dev_del_ref(pdev);
-		async_answer_0(callid, EEXISTS);
+		async_answer_0(callid, EEXIST);
 		printf(NAME ": Warning, driver tried to register `%s' twice.\n",
 		    fun_name);
@@ -587,5 +586,5 @@
 
 /** Function for handling connections from a driver to the device manager. */
-void devman_connection_driver(ipc_callid_t iid, ipc_call_t *icall)
+void devman_connection_driver(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
 	client_t *client;
Index: uspace/srv/devman/drv_conn.h
===================================================================
--- uspace/srv/devman/drv_conn.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/devman/drv_conn.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -37,5 +37,5 @@
 #include "devman.h"
 
-extern void devman_connection_driver(ipc_callid_t, ipc_call_t *);
+extern void devman_connection_driver(ipc_callid_t, ipc_call_t *, void *);
 
 #endif
Index: uspace/srv/devman/loc.c
===================================================================
--- uspace/srv/devman/loc.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/devman/loc.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -59,6 +59,5 @@
 	}
 	
-	loc_service_register_with_iface(loc_pathname,
-	    &fun->service_id, DEVMAN_CONNECT_FROM_LOC);
+	loc_service_register(loc_pathname, &fun->service_id);
 	
 	tree_add_loc_function(tree, fun);
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/devman/main.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -49,5 +49,4 @@
 #include <io/log.h>
 #include <ipc/devman.h>
-#include <ipc/driver.h>
 #include <loc.h>
 
@@ -66,23 +65,23 @@
 dev_tree_t device_tree;
 
-static void devman_forward(ipc_callid_t iid, ipc_call_t *icall,
-    bool drv_to_parent)
+static void devman_connection_device(ipc_callid_t iid, ipc_call_t *icall,
+    void *arg)
 {
 	devman_handle_t handle = IPC_GET_ARG2(*icall);
-	devman_handle_t fwd_h;
-	fun_node_t *fun = NULL;
 	dev_node_t *dev = NULL;
 	
-	fun = find_fun_node(&device_tree, handle);
-	if (fun == NULL)
+	fun_node_t *fun = find_fun_node(&device_tree, handle);
+	if (fun == NULL) {
 		dev = find_dev_node(&device_tree, handle);
-	else {
+	} else {
 		fibril_rwlock_read_lock(&device_tree.rwlock);
+		
 		dev = fun->dev;
 		if (dev != NULL)
 			dev_add_ref(dev);
+		
 		fibril_rwlock_read_unlock(&device_tree.rwlock);
 	}
-
+	
 	/*
 	 * For a valid function to connect to we need a device. The root
@@ -97,6 +96,6 @@
 		goto cleanup;
 	}
-
-	if (fun == NULL && !drv_to_parent) {
+	
+	if (fun == NULL) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, NAME ": devman_forward error - cannot "
 		    "connect to handle %" PRIun ", refers to a device.",
@@ -106,19 +105,8 @@
 	}
 	
-	driver_t *driver = NULL;
-	
 	fibril_rwlock_read_lock(&device_tree.rwlock);
 	
-	if (drv_to_parent) {
-		/* Connect to parent function of a device (or device function). */
-		if (dev->pfun->dev != NULL)
-			driver = dev->pfun->dev->drv;
-		
-		fwd_h = dev->pfun->handle;
-	} else {
-		/* Connect to the specified function */
-		driver = dev->drv;
-		fwd_h = handle;
-	}
+	/* Connect to the specified function */
+	driver_t *driver = dev->drv;
 	
 	fibril_rwlock_read_unlock(&device_tree.rwlock);
@@ -130,10 +118,4 @@
 		goto cleanup;
 	}
-	
-	int method;
-	if (drv_to_parent)
-		method = DRIVER_DRIVER;
-	else
-		method = DRIVER_CLIENT;
 	
 	if (!driver->sess) {
@@ -143,5 +125,5 @@
 		goto cleanup;
 	}
-
+	
 	if (fun != NULL) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG,
@@ -155,5 +137,5 @@
 	
 	async_exch_t *exch = async_exchange_begin(driver->sess);
-	async_forward_fast(iid, exch, method, fwd_h, 0, IPC_FF_NONE);
+	async_forward_fast(iid, exch, INTERFACE_DDF_CLIENT, handle, 0, IPC_FF_NONE);
 	async_exchange_end(exch);
 	
@@ -166,20 +148,95 @@
 }
 
-/** Function for handling connections from a client forwarded by the location
- * service to the device manager. */
-static void devman_connection_loc(ipc_callid_t iid, ipc_call_t *icall)
-{
+static void devman_connection_parent(ipc_callid_t iid, ipc_call_t *icall,
+    void *arg)
+{
+	devman_handle_t handle = IPC_GET_ARG2(*icall);
+	dev_node_t *dev = NULL;
+	
+	fun_node_t *fun = find_fun_node(&device_tree, handle);
+	if (fun == NULL) {
+		dev = find_dev_node(&device_tree, handle);
+	} else {
+		fibril_rwlock_read_lock(&device_tree.rwlock);
+		
+		dev = fun->dev;
+		if (dev != NULL)
+			dev_add_ref(dev);
+		
+		fibril_rwlock_read_unlock(&device_tree.rwlock);
+	}
+	
+	/*
+	 * For a valid function to connect to we need a device. The root
+	 * function, for example, has no device and cannot be connected to.
+	 * This means @c dev needs to be valid regardless whether we are
+	 * connecting to a device or to a function.
+	 */
+	if (dev == NULL) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "IPC forwarding failed - no device or "
+		    "function with handle %" PRIun " was found.", handle);
+		async_answer_0(iid, ENOENT);
+		goto cleanup;
+	}
+	
+	driver_t *driver = NULL;
+	
+	fibril_rwlock_read_lock(&device_tree.rwlock);
+	
+	/* Connect to parent function of a device (or device function). */
+	if (dev->pfun->dev != NULL)
+		driver = dev->pfun->dev->drv;
+	
+	devman_handle_t fun_handle = dev->pfun->handle;
+	
+	fibril_rwlock_read_unlock(&device_tree.rwlock);
+	
+	if (driver == NULL) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "IPC forwarding refused - " \
+		    "the device %" PRIun " is not in usable state.", handle);
+		async_answer_0(iid, ENOENT);
+		goto cleanup;
+	}
+	
+	if (!driver->sess) {
+		log_msg(LOG_DEFAULT, LVL_ERROR,
+		    "Could not forward to driver `%s'.", driver->name);
+		async_answer_0(iid, EINVAL);
+		goto cleanup;
+	}
+	
+	if (fun != NULL) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG,
+		    "Forwarding request for `%s' function to driver `%s'.",
+		    fun->pathname, driver->name);
+	} else {
+		log_msg(LOG_DEFAULT, LVL_DEBUG,
+		    "Forwarding request for `%s' device to driver `%s'.",
+		    dev->pfun->pathname, driver->name);
+	}
+	
+	async_exch_t *exch = async_exchange_begin(driver->sess);
+	async_forward_fast(iid, exch, INTERFACE_DDF_DRIVER, fun_handle, 0, IPC_FF_NONE);
+	async_exchange_end(exch);
+	
+cleanup:
+	if (dev != NULL)
+		dev_del_ref(dev);
+	
+	if (fun != NULL)
+		fun_del_ref(fun);
+}
+
+static void devman_forward(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+{
+	iface_t iface = IPC_GET_ARG1(*icall);
 	service_id_t service_id = IPC_GET_ARG2(*icall);
-	fun_node_t *fun;
-	dev_node_t *dev;
-	devman_handle_t handle;
-	driver_t *driver;
-
-	fun = find_loc_tree_function(&device_tree, service_id);
+	
+	fun_node_t *fun = find_loc_tree_function(&device_tree, service_id);
 	
 	fibril_rwlock_read_lock(&device_tree.rwlock);
 	
-	if (fun == NULL || fun->dev == NULL || fun->dev->drv == NULL) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "devman_connection_loc(): function "
+	if ((fun == NULL) || (fun->dev == NULL) || (fun->dev->drv == NULL)) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "devman_forward(): function "
 		    "not found.\n");
 		fibril_rwlock_read_unlock(&device_tree.rwlock);
@@ -188,49 +245,19 @@
 	}
 	
-	dev = fun->dev;
-	driver = dev->drv;
-	handle = fun->handle;
+	dev_node_t *dev = fun->dev;
+	driver_t *driver = dev->drv;
+	devman_handle_t handle = fun->handle;
 	
 	fibril_rwlock_read_unlock(&device_tree.rwlock);
 	
 	async_exch_t *exch = async_exchange_begin(driver->sess);
-	async_forward_fast(iid, exch, DRIVER_CLIENT, handle, 0,
-	    IPC_FF_NONE);
+	async_forward_fast(iid, exch, iface, handle, 0, IPC_FF_NONE);
 	async_exchange_end(exch);
 	
 	log_msg(LOG_DEFAULT, LVL_DEBUG,
-	    "Forwarding loc service request for `%s' function to driver `%s'.",
+	    "Forwarding service request for `%s' function to driver `%s'.",
 	    fun->pathname, driver->name);
-
+	
 	fun_del_ref(fun);
-}
-
-/** Function for handling connections to device manager. */
-static void devman_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
-{
-	/* Select port. */
-	switch ((sysarg_t) (IPC_GET_ARG1(*icall))) {
-	case DEVMAN_DRIVER:
-		devman_connection_driver(iid, icall);
-		break;
-	case DEVMAN_CLIENT:
-		devman_connection_client(iid, icall);
-		break;
-	case DEVMAN_CONNECT_TO_DEVICE:
-		/* Connect client to selected device. */
-		devman_forward(iid, icall, false);
-		break;
-	case DEVMAN_CONNECT_FROM_LOC:
-		/* Someone connected through loc node. */
-		devman_connection_loc(iid, icall);
-		break;
-	case DEVMAN_CONNECT_TO_PARENTS_DEVICE:
-		/* Connect client to selected device. */
-		devman_forward(iid, icall, true);
-		break;
-	default:
-		/* No such interface */
-		async_answer_0(iid, ENOENT);
-	}
 }
 
@@ -298,5 +325,27 @@
 	async_set_client_data_constructor(devman_client_data_create);
 	async_set_client_data_destructor(devman_client_data_destroy);
-	async_set_client_connection(devman_connection);
+	
+	port_id_t port;
+	rc = async_create_port(INTERFACE_DDF_DRIVER,
+	    devman_connection_driver, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = async_create_port(INTERFACE_DDF_CLIENT,
+	    devman_connection_client, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = async_create_port(INTERFACE_DEVMAN_DEVICE,
+	    devman_connection_device, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = async_create_port(INTERFACE_DEVMAN_PARENT,
+	    devman_connection_parent, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	async_set_fallback_port_handler(devman_forward, NULL);
 	
 	if (!devman_init()) {
Index: uspace/srv/devman/match.c
===================================================================
--- uspace/srv/devman/match.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/devman/match.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -31,4 +31,5 @@
  */
 
+#include <errno.h>
 #include <fcntl.h>
 #include <io/log.h>
@@ -197,5 +198,5 @@
 	if (fd < 0) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to open `%s' for reading: %s.",
-		    conf_path, str_error(fd));
+		    conf_path, str_error(errno));
 		goto cleanup;
 	}
@@ -217,8 +218,8 @@
 	}
 	
-	ssize_t read_bytes = read_all(fd, buf, len);
+	ssize_t read_bytes = read(fd, buf, len);
 	if (read_bytes <= 0) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to read file '%s' (%zd).", conf_path,
-		    read_bytes);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to read file '%s' (%d).", conf_path,
+		    errno);
 		goto cleanup;
 	}
Index: uspace/srv/fs/cdfs/cdfs.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/cdfs/cdfs.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -73,6 +73,6 @@
 	}
 	
-	async_sess_t *vfs_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-	    SERVICE_VFS, 0, 0);
+	async_sess_t *vfs_sess = service_connect_blocking(SERVICE_VFS,
+	    INTERFACE_VFS_DRIVER, 0);
 	if (!vfs_sess) {
 		printf("%s: Unable to connect to VFS\n", NAME);
Index: uspace/srv/fs/cdfs/cdfs_ops.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/cdfs/cdfs_ops.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -1025,5 +1025,5 @@
 {
 	/* Initialize the block layer */
-	int rc = block_init(EXCHANGE_SERIALIZE, service_id, BLOCK_SIZE);
+	int rc = block_init(service_id, BLOCK_SIZE);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/exfat/exfat.c
===================================================================
--- uspace/srv/fs/exfat/exfat.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/exfat/exfat.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -75,6 +75,6 @@
 		goto err;
 
-	async_sess_t *vfs_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-	    SERVICE_VFS, 0, 0);
+	async_sess_t *vfs_sess = service_connect_blocking(SERVICE_VFS,
+	    INTERFACE_VFS_DRIVER, 0);
 	if (!vfs_sess) {
 		printf(NAME ": failed to connect to VFS\n");
Index: uspace/srv/fs/exfat/exfat_ops.c
===================================================================
--- uspace/srv/fs/exfat/exfat_ops.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/exfat/exfat_ops.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -1067,5 +1067,5 @@
 
 	/* initialize libblock */
-	rc = block_init(EXCHANGE_SERIALIZE, service_id, BS_SIZE);
+	rc = block_init(service_id, BS_SIZE);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/ext4fs/Makefile
===================================================================
--- uspace/srv/fs/ext4fs/Makefile	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/ext4fs/Makefile	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -28,6 +28,7 @@
 
 USPACE_PREFIX = ../../..
-LIBS = $(LIBBLOCK_PREFIX)/libblock.a $(LIBFS_PREFIX)/libfs.a $(LIBEXT4_PREFIX)/libext4.a
-EXTRA_CFLAGS += -I$(LIBBLOCK_PREFIX) -I$(LIBFS_PREFIX) -I$(LIBEXT4_PREFIX)
+LIBS = $(LIBBLOCK_PREFIX)/libblock.a $(LIBFS_PREFIX)/libfs.a \
+    $(LIBEXT4_PREFIX)/libext4.a $(LIBCRYPTO_PREFIX)/libcrypto.a
+EXTRA_CFLAGS += -I$(LIBBLOCK_PREFIX) -I$(LIBFS_PREFIX) -I$(LIBEXT4_PREFIX) -I$(LIBCRYPTO_PREFIX)
 BINARY = ext4fs
 STATIC_NEEDED = y
Index: uspace/srv/fs/ext4fs/ext4fs.c
===================================================================
--- uspace/srv/fs/ext4fs/ext4fs.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/ext4fs/ext4fs.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -65,6 +65,6 @@
 	}
 	
-	async_sess_t *vfs_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-	    SERVICE_VFS, 0, 0);
+	async_sess_t *vfs_sess = service_connect_blocking(SERVICE_VFS,
+	    INTERFACE_VFS_DRIVER, 0);
 	if (!vfs_sess) {
 		printf("%s: Failed to connect to VFS\n", NAME);
Index: uspace/srv/fs/fat/fat.c
===================================================================
--- uspace/srv/fs/fat/fat.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/fat/fat.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -75,6 +75,6 @@
 		goto err;
 	
-	async_sess_t *vfs_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-	    SERVICE_VFS, 0, 0);
+	async_sess_t *vfs_sess = service_connect_blocking(SERVICE_VFS,
+	    INTERFACE_VFS_DRIVER, 0);
 	if (!vfs_sess) {
 		printf(NAME ": failed to connect to VFS\n");
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/fat/fat_ops.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -939,5 +939,5 @@
 
 	/* initialize libblock */
-	rc = block_init(EXCHANGE_SERIALIZE, service_id, BS_SIZE);
+	rc = block_init(service_id, BS_SIZE);
 	if (rc != EOK) {
 		free(instance);
Index: uspace/srv/fs/locfs/locfs.c
===================================================================
--- uspace/srv/fs/locfs/locfs.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/locfs/locfs.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -77,6 +77,6 @@
 	}
 	
-	async_sess_t *vfs_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-	    SERVICE_VFS, 0, 0);
+	async_sess_t *vfs_sess = service_connect_blocking(SERVICE_VFS,
+	    INTERFACE_VFS_DRIVER, 0);
 	if (!vfs_sess) {
 		printf("%s: Unable to connect to VFS\n", NAME);
Index: uspace/srv/fs/locfs/locfs_ops.c
===================================================================
--- uspace/srv/fs/locfs/locfs_ops.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/locfs/locfs_ops.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -264,6 +264,6 @@
 			fibril_mutex_unlock(&services_mutex);
 			
-			async_sess_t *sess = loc_service_connect(
-			    EXCHANGE_SERIALIZE, node->service_id, 0);
+			async_sess_t *sess = loc_service_connect(node->service_id,
+			    INTERFACE_FS, 0);
 			
 			fibril_mutex_lock(&services_mutex);
Index: uspace/srv/fs/mfs/mfs.c
===================================================================
--- uspace/srv/fs/mfs/mfs.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/mfs/mfs.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -73,6 +73,6 @@
 	}
 
-	async_sess_t *vfs_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-	    SERVICE_VFS, 0, 0);
+	async_sess_t *vfs_sess = service_connect_blocking(SERVICE_VFS,
+	    INTERFACE_VFS_DRIVER, 0);
 
 	if (!vfs_sess) {
Index: uspace/srv/fs/mfs/mfs_ops.c
===================================================================
--- uspace/srv/fs/mfs/mfs_ops.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/mfs/mfs_ops.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -161,5 +161,5 @@
 
 	/* initialize libblock */
-	rc = block_init(EXCHANGE_SERIALIZE, service_id, 4096);
+	rc = block_init(service_id, 4096);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/tmpfs/tmpfs.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/tmpfs/tmpfs.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -80,6 +80,6 @@
 	}
 	
-	async_sess_t *vfs_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-	    SERVICE_VFS, 0, 0);
+	async_sess_t *vfs_sess = service_connect_blocking(SERVICE_VFS,
+	    INTERFACE_VFS_DRIVER, 0);
 	if (!vfs_sess) {
 		printf(NAME ": Unable to connect to VFS\n");
Index: uspace/srv/fs/tmpfs/tmpfs_dump.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs_dump.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/tmpfs/tmpfs_dump.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -169,5 +169,5 @@
 	int rc;
 
-	rc = block_init(EXCHANGE_SERIALIZE, dsid, TMPFS_COMM_SIZE);
+	rc = block_init(dsid, TMPFS_COMM_SIZE);
 	if (rc != EOK)
 		return false; 
Index: uspace/srv/fs/udf/udf.c
===================================================================
--- uspace/srv/fs/udf/udf.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/udf/udf.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -74,5 +74,5 @@
 	
 	async_sess_t *vfs_sess =
-	    service_connect_blocking(EXCHANGE_SERIALIZE, SERVICE_VFS, 0, 0);
+	    service_connect_blocking(SERVICE_VFS, INTERFACE_VFS_DRIVER, 0);
 	if (!vfs_sess) {
 		log_msg(LOG_DEFAULT, LVL_FATAL, "Failed to connect to VFS");
Index: uspace/srv/fs/udf/udf_ops.c
===================================================================
--- uspace/srv/fs/udf/udf_ops.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/fs/udf/udf_ops.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -325,5 +325,5 @@
 	
 	/* initialize block cache */
-	int rc = block_init(EXCHANGE_SERIALIZE, service_id, MAX_SIZE);
+	int rc = block_init(service_id, MAX_SIZE);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/hid/compositor/compositor.c
===================================================================
--- uspace/srv/hid/compositor/compositor.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/compositor/compositor.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -896,5 +896,5 @@
 	ipc_call_t call;
 	ipc_callid_t callid;
-	service_id_t service_id = (service_id_t) IPC_GET_ARG1(*icall);
+	service_id_t service_id = (service_id_t) IPC_GET_ARG2(*icall);
 
 	/* Allocate resources for new window and register it to the location service. */
@@ -1175,5 +1175,5 @@
 	async_sess_t *sess;
 
-	sess = loc_service_connect(EXCHANGE_SERIALIZE, sid, 0);
+	sess = loc_service_connect(sid, INTERFACE_DDF, 0);
 	if (sess == NULL) {
 		printf("%s: Unable to connect to visualizer %s\n", NAME, svc);
@@ -1182,5 +1182,9 @@
 
 	async_exch_t *exch = async_exchange_begin(sess);
-	rc = async_connect_to_me(exch, sid, 0, 0, vsl_notifications, NULL);
+	
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_VISUALIZER_CB, 0, 0,
+	    vsl_notifications, NULL, &port);
+	
 	async_exchange_end(exch);
 
@@ -2145,5 +2149,5 @@
 	}
 
-	sess = loc_service_connect(EXCHANGE_ATOMIC, dsid, 0);
+	sess = loc_service_connect(dsid, INTERFACE_INPUT, 0);
 	if (sess == NULL) {
 		printf("%s: Unable to connect to input service %s\n", NAME,
@@ -2240,5 +2244,5 @@
 	
 	/* Register compositor server. */
-	async_set_client_connection(client_connection);
+	async_set_fallback_port_handler(client_connection, NULL);
 	
 	int rc = loc_server_register(NAME);
Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/console/console.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -508,5 +508,5 @@
 	
 	for (size_t i = 0; i < CONSOLE_COUNT; i++) {
-		if (consoles[i].dsid == (service_id_t) IPC_GET_ARG1(*icall)) {
+		if (consoles[i].dsid == (service_id_t) IPC_GET_ARG2(*icall)) {
 			cons = &consoles[i];
 			break;
@@ -536,5 +536,5 @@
 	}
 
-	sess = loc_service_connect(EXCHANGE_ATOMIC, dsid, 0);
+	sess = loc_service_connect(dsid, INTERFACE_INPUT, 0);
 	if (sess == NULL) {
 		printf("%s: Unable to connect to input service %s\n", NAME,
@@ -561,5 +561,5 @@
 	int rc = loc_service_get_id(svc, &dsid, 0);
 	if (rc == EOK) {
-		sess = loc_service_connect(EXCHANGE_SERIALIZE, dsid, 0);
+		sess = loc_service_connect(dsid, INTERFACE_OUTPUT, 0);
 		if (sess == NULL) {
 			printf("%s: Unable to connect to output service %s\n",
@@ -586,5 +586,5 @@
 	
 	/* Register server */
-	async_set_client_connection(client_connection);
+	async_set_fallback_port_handler(client_connection, NULL);
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
